> ## Documentation Index
> Fetch the complete documentation index at: https://docs-v2.sortx.co.uk/llms.txt
> Use this file to discover all available pages before exploring further.

# Update works programme

> Edit a works programme



## OpenAPI

````yaml /openapi.json patch /planned-maintenance/works-programmes/{id}
openapi: 3.1.0
info:
  title: SortX API
  version: 1.0.0
  description: >-
    Reactive repairs, planned maintenance, compliance and the repairs desk for
    UK letting agents and property managers.
servers:
  - url: https://api.sortx.co.uk
    description: Production
security: []
tags:
  - name: tenants
  - name: entitlements
  - name: events
  - name: workspace-settings
  - name: operational-catalogues
  - name: money
  - name: contacts
  - name: properties
  - name: address-lookup
  - name: tenancies
  - name: contractor-invoices
  - name: keys
  - name: inspections
  - name: handovers
  - name: planned-maintenance
  - name: contractors
  - name: company-onboarding
  - name: documents
  - name: compliance
  - name: activity
  - name: tasks
  - name: today
  - name: desk
  - name: people
  - name: property-boards
  - name: reports
  - name: workspace-search
  - name: calendar
  - name: telephony
  - name: maintenance-pro
  - name: front-desk
  - name: maintenance-pro-public
  - name: maintenance-pro-contractor
paths:
  /planned-maintenance/works-programmes/{id}:
    patch:
      tags:
        - planned-maintenance
      summary: Update works programme
      description: Edit a works programme
      operationId: planned-maintenance.updateWorksProgramme
      parameters:
        - name: id
          in: path
          schema:
            type: string
          required: true
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                expectedRevision:
                  anyOf:
                    - type: number
                    - type: string
                      enum:
                        - Infinity
                        - '-Infinity'
                        - NaN
                name:
                  anyOf:
                    - type: string
                    - type: 'null'
                description:
                  anyOf:
                    - type: string
                    - type: 'null'
                status:
                  anyOf:
                    - type: string
                      enum:
                        - planning
                        - in_progress
                        - complete
                        - cancelled
                    - type: 'null'
                contractorContactId:
                  anyOf:
                    - anyOf:
                        - type: string
                        - type: 'null'
                    - type: 'null'
                quotesReceived:
                  anyOf:
                    - anyOf:
                        - type: number
                        - type: string
                          enum:
                            - Infinity
                            - '-Infinity'
                            - NaN
                    - type: 'null'
                contractorDecisionBy:
                  anyOf:
                    - anyOf:
                        - type: string
                        - type: 'null'
                    - type: 'null'
                startsOn:
                  anyOf:
                    - type: string
                    - type: 'null'
                endsOn:
                  anyOf:
                    - type: string
                    - type: 'null'
                budgetMinor:
                  anyOf:
                    - anyOf:
                        - type: number
                        - type: string
                          enum:
                            - Infinity
                            - '-Infinity'
                            - NaN
                    - type: 'null'
                budgetLineId:
                  anyOf:
                    - anyOf:
                        - type: string
                        - type: 'null'
                    - type: 'null'
                landlordApprovalAboveMinor:
                  anyOf:
                    - anyOf:
                        - anyOf:
                            - type: number
                            - type: string
                              enum:
                                - Infinity
                                - '-Infinity'
                                - NaN
                        - type: 'null'
                    - type: 'null'
                followOnCycleId:
                  anyOf:
                    - anyOf:
                        - type: string
                        - type: 'null'
                    - type: 'null'
                followOnDueOn:
                  anyOf:
                    - anyOf:
                        - type: string
                        - type: 'null'
                    - type: 'null'
                completedOn:
                  anyOf:
                    - anyOf:
                        - type: string
                        - type: 'null'
                    - type: 'null'
              required:
                - expectedRevision
              additionalProperties: false
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WorksProgrammeDetailRow'
        '400':
          description: >-
            TenantCreateRejected | ConfigMissing | IntegrationRejected |
            AuthRejected | RegistrationRejected | UnknownIntegration |
            WebhookUnroutable | RateUnavailable
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/TenantCreateRejectedEncoded'
                  - $ref: '#/components/schemas/ConfigMissingEncoded'
                  - $ref: '#/components/schemas/IntegrationRejectedEncoded'
                  - $ref: '#/components/schemas/AuthRejectedEncoded'
                  - $ref: '#/components/schemas/RegistrationRejectedEncoded'
                  - $ref: '#/components/schemas/UnknownIntegrationEncoded'
                  - $ref: '#/components/schemas/WebhookUnroutableEncoded'
                  - $ref: '#/components/schemas/RateUnavailableEncoded'
                  - $ref: '#/components/schemas/PlannedInputInvalid'
        '401':
          description: Unauthenticated | WebhookRejected | ApiKeyRejected
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/UnauthenticatedEncoded'
                  - $ref: '#/components/schemas/WebhookRejectedEncoded'
                  - $ref: '#/components/schemas/ApiKeyRejectedEncoded'
        '402':
          description: TenantSuspended | PlanRequired
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/TenantSuspendedEncoded'
                  - $ref: '#/components/schemas/PlanRequiredEncoded'
        '403':
          description: >-
            EntitlementMissing | NotAMember | ScopeUnknown | ScopeMissing |
            TenantMismatch | WorkspaceOwnerRequired | WorkspaceRoleRequired
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/EntitlementMissingEncoded'
                  - $ref: '#/components/schemas/NotAMemberEncoded'
                  - $ref: '#/components/schemas/ScopeUnknownEncoded'
                  - $ref: '#/components/schemas/ScopeMissingEncoded'
                  - $ref: '#/components/schemas/TenantMismatchEncoded'
                  - $ref: '#/components/schemas/WorkspaceOwnerRequiredEncoded'
                  - $ref: '#/components/schemas/WorkspaceRoleRequiredEncoded'
        '404':
          description: TenantNotFound | ModuleRequestNotFound
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/TenantNotFoundEncoded'
                  - $ref: '#/components/schemas/ModuleRequestNotFoundEncoded'
                  - $ref: '#/components/schemas/PlannedNotFound'
        '409':
          description: WebhookDuplicate | RegistrationConflict | MoneyBusy
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/WebhookDuplicateEncoded'
                  - $ref: '#/components/schemas/RegistrationConflictEncoded'
                  - $ref: '#/components/schemas/PlannedStale'
                  - $ref: '#/components/schemas/PlannedRequestConflict'
                  - $ref: '#/components/schemas/PlannedTransitionInvalid'
                  - $ref: '#/components/schemas/MoneyBusyEncoded'
        '429':
          description: RateLimited
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RateLimitedEncoded'
        '503':
          description: IntegrationUnavailable
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IntegrationUnavailableEncoded'
      security:
        - apiKey: []
components:
  schemas:
    WorksProgrammeDetailRow:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        description:
          type: string
        status:
          type: string
          enum:
            - planning
            - in_progress
            - complete
            - cancelled
        contractorContactId:
          anyOf:
            - type: string
            - type: 'null'
        contractorName:
          anyOf:
            - type: string
            - type: 'null'
        quotesReceived:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        contractorDecisionBy:
          anyOf:
            - type: string
            - type: 'null'
        startsOn:
          type: string
        endsOn:
          type: string
        completedOn:
          anyOf:
            - type: string
            - type: 'null'
        properties:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        propertiesDone:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        budgetMinor:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        spentMinor:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        committedMinor:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        leftMinor:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        awaitingApproval:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        landlordApprovalAboveMinor:
          anyOf:
            - anyOf:
                - type: number
                - type: string
                  enum:
                    - Infinity
                    - '-Infinity'
                    - NaN
            - type: 'null'
        budgetLineId:
          anyOf:
            - type: string
            - type: 'null'
        followOnCycleId:
          anyOf:
            - type: string
            - type: 'null'
        followOnDueOn:
          anyOf:
            - type: string
            - type: 'null'
        nextAction:
          anyOf:
            - anyOf:
                - type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - approval
                    propertyLabel:
                      type: string
                    amountMinor:
                      anyOf:
                        - type: number
                        - type: string
                          enum:
                            - Infinity
                            - '-Infinity'
                            - NaN
                  required:
                    - kind
                    - propertyLabel
                    - amountMinor
                  additionalProperties: false
                - type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - choose_contractor
                    by:
                      type: string
                  required:
                    - kind
                    - by
                  additionalProperties: false
                - type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - next_job
                    propertyLabel:
                      type: string
                    'on':
                      type: string
                  required:
                    - kind
                    - propertyLabel
                    - 'on'
                  additionalProperties: false
                - type: object
                  properties:
                    kind:
                      type: string
                      enum:
                        - follow_on_cycle
                    year:
                      anyOf:
                        - type: number
                        - type: string
                          enum:
                            - Infinity
                            - '-Infinity'
                            - NaN
                  required:
                    - kind
                    - year
                  additionalProperties: false
            - type: 'null'
        nextActionLabel:
          anyOf:
            - type: string
            - type: 'null'
        revision:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        createdAt:
          type: string
        updatedAt:
          type: string
        jobs:
          type: array
          items:
            $ref: '#/components/schemas/WorksJobRow'
      required:
        - id
        - name
        - description
        - status
        - contractorContactId
        - contractorName
        - quotesReceived
        - contractorDecisionBy
        - startsOn
        - endsOn
        - completedOn
        - properties
        - propertiesDone
        - budgetMinor
        - spentMinor
        - committedMinor
        - leftMinor
        - awaitingApproval
        - landlordApprovalAboveMinor
        - budgetLineId
        - followOnCycleId
        - followOnDueOn
        - nextAction
        - nextActionLabel
        - revision
        - createdAt
        - updatedAt
        - jobs
      additionalProperties: false
    TenantCreateRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - TenantCreateRejected
        reason:
          type: string
        field:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - _tag
        - reason
      additionalProperties: false
    ConfigMissingEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ConfigMissing
        key:
          type: string
      required:
        - _tag
        - key
      additionalProperties: false
    IntegrationRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - IntegrationRejected
        integration:
          type: string
        reason:
          type: string
      required:
        - _tag
        - integration
        - reason
      additionalProperties: false
    AuthRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - AuthRejected
        code:
          type: string
        message:
          type: string
      required:
        - _tag
        - code
        - message
      additionalProperties: false
    RegistrationRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - RegistrationRejected
        message:
          type: string
        field:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - _tag
        - message
      additionalProperties: false
    UnknownIntegrationEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - UnknownIntegration
        integration:
          type: string
      required:
        - _tag
        - integration
      additionalProperties: false
    WebhookUnroutableEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - WebhookUnroutable
        integration:
          type: string
        reason:
          type: string
      required:
        - _tag
        - integration
        - reason
      additionalProperties: false
    RateUnavailableEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - RateUnavailable
        base:
          type: string
        quote:
          type: string
        'on':
          type: string
      required:
        - _tag
        - base
        - quote
        - 'on'
      additionalProperties: false
    PlannedInputInvalid:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - PlannedInputInvalid
        field:
          type: string
        message:
          type: string
      required:
        - _tag
        - field
        - message
      additionalProperties: false
    UnauthenticatedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - Unauthenticated
      required:
        - _tag
      additionalProperties: false
    WebhookRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - WebhookRejected
        integration:
          type: string
        reason:
          type: string
      required:
        - _tag
        - integration
        - reason
      additionalProperties: false
    ApiKeyRejectedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ApiKeyRejected
      required:
        - _tag
      additionalProperties: false
    TenantSuspendedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - TenantSuspended
        tenantId:
          type: string
        reason:
          type: string
      required:
        - _tag
        - tenantId
        - reason
      additionalProperties: false
    PlanRequiredEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - PlanRequired
        tenantId:
          type: string
      required:
        - _tag
        - tenantId
      additionalProperties: false
    EntitlementMissingEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - EntitlementMissing
        tenantId:
          type: string
        moduleId:
          type: string
      required:
        - _tag
        - tenantId
        - moduleId
      additionalProperties: false
    NotAMemberEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - NotAMember
        userId:
          type: string
        slug:
          type: string
      required:
        - _tag
        - userId
        - slug
      additionalProperties: false
    ScopeUnknownEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ScopeUnknown
        scope:
          type: string
      required:
        - _tag
        - scope
      additionalProperties: false
    ScopeMissingEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ScopeMissing
        scope:
          type: string
      required:
        - _tag
        - scope
      additionalProperties: false
    TenantMismatchEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - TenantMismatch
        header:
          type: string
        organizationId:
          type: string
      required:
        - _tag
        - header
        - organizationId
      additionalProperties: false
    WorkspaceOwnerRequiredEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - WorkspaceOwnerRequired
      required:
        - _tag
      additionalProperties: false
    WorkspaceRoleRequiredEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - WorkspaceRoleRequired
        role:
          anyOf:
            - type: string
            - type: 'null'
        required:
          type: array
          items:
            type: string
        message:
          type: string
      required:
        - _tag
        - role
        - required
        - message
      additionalProperties: false
    TenantNotFoundEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - TenantNotFound
        slug:
          type: string
      required:
        - _tag
        - slug
      additionalProperties: false
    ModuleRequestNotFoundEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - ModuleRequestNotFound
        id:
          type: string
      required:
        - _tag
        - id
      additionalProperties: false
    PlannedNotFound:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - PlannedNotFound
        kind:
          type: string
        id:
          type: string
      required:
        - _tag
        - kind
        - id
      additionalProperties: false
    WebhookDuplicateEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - WebhookDuplicate
        integration:
          type: string
        externalId:
          type: string
      required:
        - _tag
        - integration
        - externalId
      additionalProperties: false
    RegistrationConflictEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - RegistrationConflict
        message:
          type: string
        field:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - _tag
        - message
      additionalProperties: false
    PlannedStale:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - PlannedStale
        revision:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        expectedRevision:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        message:
          type: string
      required:
        - _tag
        - revision
        - expectedRevision
        - message
      additionalProperties: false
    PlannedRequestConflict:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - PlannedRequestConflict
        message:
          type: string
      required:
        - _tag
        - message
      additionalProperties: false
    PlannedTransitionInvalid:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - PlannedTransitionInvalid
        code:
          type: string
        message:
          type: string
      required:
        - _tag
        - code
        - message
      additionalProperties: false
    MoneyBusyEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - MoneyBusy
        message:
          type: string
      required:
        - _tag
        - message
      additionalProperties: false
    RateLimitedEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - RateLimited
        key:
          type: string
        retryAfterSeconds:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
        message:
          type: string
      required:
        - _tag
        - key
        - retryAfterSeconds
        - message
      additionalProperties: false
    IntegrationUnavailableEncoded:
      type: object
      properties:
        _tag:
          type: string
          enum:
            - IntegrationUnavailable
        integration:
          type: string
        detail:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - _tag
        - integration
      additionalProperties: false
    WorksJobRow:
      type: object
      properties:
        id:
          type: string
        programmeId:
          type: string
        propertyId:
          type: string
        addressLine:
          anyOf:
            - type: string
            - type: 'null'
        area:
          anyOf:
            - type: string
            - type: 'null'
        kind:
          type: string
          enum:
            - works
            - logistics
        title:
          type: string
        status:
          type: string
          enum:
            - not_booked
            - booked
            - completed
            - cancelled
        scheduledOn:
          anyOf:
            - type: string
            - type: 'null'
        startMinute:
          anyOf:
            - anyOf:
                - type: number
                - type: string
                  enum:
                    - Infinity
                    - '-Infinity'
                    - NaN
            - type: 'null'
        endMinute:
          anyOf:
            - anyOf:
                - type: number
                - type: string
                  enum:
                    - Infinity
                    - '-Infinity'
                    - NaN
            - type: 'null'
        quoteMinor:
          anyOf:
            - anyOf:
                - type: number
                - type: string
                  enum:
                    - Infinity
                    - '-Infinity'
                    - NaN
            - type: 'null'
        costMinor:
          anyOf:
            - anyOf:
                - type: number
                - type: string
                  enum:
                    - Infinity
                    - '-Infinity'
                    - NaN
            - type: 'null'
        approvalState:
          anyOf:
            - type: string
              enum:
                - required
                - sent
                - approved
                - declined
            - type: 'null'
        tenantNotifiedAt:
          anyOf:
            - type: string
            - type: 'null'
        accessRefusedAt:
          anyOf:
            - type: string
            - type: 'null'
        accessRefusedReason:
          anyOf:
            - type: string
            - type: 'null'
        completedOn:
          anyOf:
            - type: string
            - type: 'null'
        budgetLineId:
          anyOf:
            - type: string
            - type: 'null'
        revision:
          anyOf:
            - type: number
            - type: string
              enum:
                - Infinity
                - '-Infinity'
                - NaN
      required:
        - id
        - programmeId
        - propertyId
        - addressLine
        - area
        - kind
        - title
        - status
        - scheduledOn
        - startMinute
        - endMinute
        - quoteMinor
        - costMinor
        - approvalState
        - tenantNotifiedAt
        - accessRefusedAt
        - accessRefusedReason
        - completedOn
        - budgetLineId
        - revision
      additionalProperties: false
  securitySchemes:
    apiKey:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        A workspace API key (Settings → API keys), scoped to `<group>:read` /
        `<group>:write`.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.